import 'package:flutter/material.dart';
import 'dart:async';

import 'package:flutter/services.dart';
import 'package:wmc_plugin/wmc_plugin.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String _result = 'Unknown';

  @override
  void initState() {
    super.initState();
    /*
     Haber solicitado permiso de READ_PHONE_STATE para el caso de 
     Android ya que por default se envia el codigo de identificador en null en 
     ios no es necesario
     */
    //initializeWmc();
    sendRequest();
  }
 
  Future<void> initializeWmc() async {
    String initializeWmc; 
    try {
      initializeWmc = await WmcPlugin.initialize("3s28cg4d368g24drt8g24988fds8dr3e");
    } on PlatformException {
      initializeWmc = 'Failed to initialize WMC.';
    }

    setState(() {
      _result = initializeWmc;
    });
  }

  Future<void> sendRequest() async{ 
    String result;  
    try {
      result = await WmcPlugin.request("http://dummy.restapiexample.com/api/v1/employees","GET",
                                              { 'content-type': 'application/json' },
                                              { 'userid': 'myuseridofapp' }
                                              );
    } on PlatformException {
      result = 'Failed to request';
    } 
    setState(() {
      _result = result;
    }); 
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        body: Center(
          child: Text('Running on: $_result\n'),
        ),
      ),
    );
  }
}
